unit Unit7;
{
  Copyright (C) 2013-2015 Marc SERRAU

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}
{$MODE Delphi}

interface

uses
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, FileUtil, DateUtils;

type
  TForm7 = class(TForm)
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    LabeledEdit1: TLabeledEdit;
    Label1: TLabel;
    Button1: TButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    ComboBox1: TComboBox;
    Label2: TLabel;
    CheckBoxFiltrage: TCheckBox;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
  end;

var
  Form7: TForm7;

implementation

{$R *.lfm}
uses
   Tri,Unit1;

procedure TForm7.Button1Click(Sender: TObject);
type
   T_AFOEV_AAVSO_Mm = array[1..14] of string;
var
   f_asso : TextFile;
   V,C,ligne, variable : string;
   i : longint;
   no_type,code,mois,mois_demande : integer;
   filtre_visible,ch, chtype, crAlphaMin,crAlphaMax,crDeltaMax, crDeltaMin,
   crPerMin,crPerMax,crmagmax,crmagmin                              : boolean;
   CritereAlphaMin,CritereAlphaMax,CritereDeltaMin,CritereDeltaMax,
   CriterePerMax,CriterePerMin,CritereMagMax, CritereMagMin,
   EclatMax,EclatMin                                                : real;
   AFOEV_Mm,AAVSO_Mm                                                : T_AFOEV_AAVSO_Mm;
   MinMax                                                           : String[1];
begin

    Val(Form1.LabeledEdit1.Text,CritereMagMax,code);
    Val(Form1.LabeledEdit2.Text,CritereMagMin,code);
    Val(Form1.LabeledEdit19.Text,CriterePerMax,code);
    Val(Form1.LabeledEdit20.Text,CriterePerMin,code);
    Val(Form1.LabeledEdit5.Text,CritereAlphaMax,code);
    Val(Form1.LabeledEdit6.Text,CritereAlphaMin,code);
    Val(Form1.LabeledEdit4.Text,CritereDeltaMax,code);
    Val(Form1.LabeledEdit3.Text,CritereDeltaMin,code);

    If RadioButton10.Checked then MinMax:='M' else MinMax:='m';
    mois_demande:=ComboBox1.ItemIndex+1;

//    for i:=1 to GCVS_Size do
//    begin

    if Groupbox2.Enabled then
    begin
        AssignFile(f_asso,'AFOEV'+Copy(LabeledEdit1.Text,3,2)+'.dat');
        {$I-}Reset(f_asso); {$I+}
        If IOResult=0 then
        begin

           repeat
              Readln(f_asso,ligne);
              Variable:=Copy(ligne,12,9);

//               Star:=Trim(Copy(ligne,1,10));
               V:=Trim(Copy(variable,1,Pos(' ',Variable)));
               C:=Copy(Variable,Pos(' ',Variable),length(Variable));
               If Upcase(V[1])='V' then
               begin
                  Variable:=Trim(C)+'V'+Copy('000',1,Length(V)-5)+Copy(V,2,5);
               end
               else
                  Variable:=Upcase(Trim(C)+Trim(V));
               i:=RechercheIndex(indexGCVS,GCVS_size,Variable);
               if i>0 then       { La variable a été trouvée }
               begin
                   Val(Trim(Copy(ligne,21,4)),EclatMax,Code);
                   Val(Trim(Copy(ligne,28,4)),EclatMin,Code);

                   If EclatMax>0 Then begin GCVS[i]^.Maximum:=EclatMax; GCVS[i]^.Updated:=True; end;
                   IF EclatMin>0 Then begin GCVS[i]^.Minimum:=EclatMin; GCVS[i]^.Updated:=True; end;

                   for mois:=1 to 14 do
                      AFOEV_Mm[mois]:=Copy(ligne,37+7*(mois-1),6);
                   if checkboxFiltrage.Checked then
                   begin
                       ch:=True;
                       chtype:=true;
                       if Form1.checkconstel.Checked then
                          if Table_constellation[GCVS[i]^.Constellation].Checked then ch:=true
                          else ch:=false;
                       if Form1.checkTypeVar.Checked then
                       begin
                          chtype:=false;
                          for no_type:=0 to Form1.CheckListBox2.Count-1 do
                             if Form1.CheckListBox2.Checked[no_type] then
                                if Pos(Form1.CheckListBox2.Items.Strings[no_type],GCVS[i]^.Type_variable)>0 then chtype:=true;
                       end;
                       CrMagMax:=not Form1.CheckMagMax.Checked or (GCVS[i]^.Maximum>CritereMagMax);
                       CrMagMin:=not Form1.CheckMagMin.Checked or (GCVS[i]^.Minimum<CritereMagMin);
                       CrPerMax:=not Form1.CheckPerMax.Checked or (GCVS[i]^.Periode<CriterePerMax);
                       CrPerMin:=not Form1.CheckPerMin.Checked or (GCVS[i]^.Periode>CriterePerMin);
                       CrAlphaMax:=not Form1.CheckADMax.Checked or (GCVS[i]^.Alpha<CritereAlphaMax);
                       CrAlphaMin:=not Form1.CheckADMin.Checked or (GCVS[i]^.Alpha>CritereAlphaMin);
                       CrDeltaMax:=not Form1.CheckDecMax.Checked or (GCVS[i]^.Delta<CritereDeltaMax);
                       CrDeltaMin:=not Form1.CheckDecMin.Checked or (GCVS[i]^.Delta>CritereDeltaMin);
                       filtre_visible:=CrDeltaMin and CrDeltaMax and CrAlphaMin and CrAlphaMax and CrPerMin and
                                         CrPErMax and CrMagMax and CrMagMin and ch and chtype {or (Form1.CheckBoxRefiltrer.Checked and GCVS[i]^.visible)};
                   end
                   else filtre_visible:=True;
                   GCVS[i]^.visible:=GCVS[i]^.visible
                                 or filtre_visible
                                    and
                                      (    RadioButton7.Checked
                                       or (RadioButton8.Checked and (Pos('!',Copy(ligne,33,2))>0))
                                       or (RadioButton9.Checked and (Pos('?',Copy(ligne,33,2))>0))
                                       or (RadioButton13.Checked and (Pos(MinMax,AFOEV_Mm[mois_demande])>0))
                                      ) ;
               end
           until eof(f_asso);
           closefile(f_asso);
        end;
    end;
    if Groupbox1.Enabled then
    begin
        AssignFile(f_asso,'lpv'+Copy(LabeledEdit1.Text,3,2)+'.dat');
        {$I-}Reset(f_asso); {$I+}
        If IOResult=0 then
        begin

           repeat
              Readln(f_asso,ligne);
              Variable:=Copy(ligne,15,10);

//               Star:=Trim(Copy(ligne,1,10));
               V:=Trim(Copy(variable,1,7));
               C:=Copy(Variable,8,3);
               If (V[1]='V') and (V[length(V)] in ['0'..'9']) then
               begin
                  Variable:=Trim(C)+'V'+Copy('000',1,Length(V)-5)+Copy(V,2,5);
               end
               else
                  Variable:=Trim(C)+Trim(V);
               i:=RechercheIndex(indexGCVS,GCVS_size,Variable);
               if i>0 then
               begin
                   for mois:=1 to 14 do
                      AAVSO_Mm[mois]:=Copy(ligne,42+6*(mois-1),6);
                   if checkboxFiltrage.Checked then
                   begin
                       ch:=True;
                       chtype:=true;
                       if Form1.checkconstel.Checked then
                          if Table_constellation[GCVS[i]^.Constellation].Checked then ch:=true
                          else ch:=false;
                       if Form1.checkTypeVar.Checked then
                       begin
                          chtype:=false;
                          for no_type:=0 to Form1.CheckListBox2.Count-1 do
                             if Form1.CheckListBox2.Checked[no_type] then
                                if Pos(Form1.CheckListBox2.Items.Strings[no_type],GCVS[i]^.Type_variable)>0 then chtype:=true;
                       end;
                       CrMagMax:=not Form1.CheckMagMax.Checked or (GCVS[i]^.Maximum>CritereMagMax);
                       CrMagMin:=not Form1.CheckMagMin.Checked or (GCVS[i]^.Minimum<CritereMagMin);
                       CrPerMax:=not Form1.CheckPerMax.Checked or (GCVS[i]^.Periode<CriterePerMax);
                       CrPerMin:=not Form1.CheckPerMin.Checked or (GCVS[i]^.Periode>CriterePerMin);
                       CrAlphaMax:=not Form1.CheckADMax.Checked or (GCVS[i]^.Alpha<CritereAlphaMax);
                       CrAlphaMin:=not Form1.CheckADMin.Checked or (GCVS[i]^.Alpha>CritereAlphaMin);
                       CrDeltaMax:=not Form1.CheckDecMax.Checked or (GCVS[i]^.Delta<CritereDeltaMax);
                       CrDeltaMin:=not Form1.CheckDecMin.Checked or (GCVS[i]^.Delta>CritereDeltaMin);
                       filtre_visible:=CrDeltaMin and CrDeltaMax and CrAlphaMin and CrAlphaMax and CrPerMin and
                                         CrPErMax and CrMagMax and CrMagMin and ch and chtype {or (Form1.CheckBoxRefiltrer.Checked and GCVS[i]^.visible)};
                   end
                   else filtre_visible:=True;

                   GCVS[i]^.visible:=GCVS[i]^.visible
                                 or filtre_visible
                                    and
                                      (RadioButton1.Checked or
                                      (RadioButton3.Checked and (Pos('%',Copy(ligne,26,2))>0))
                                   or (RadioButton4.Checked and (Pos('@',Copy(ligne,26,2))>0))
                                   or (RadioButton5.Checked and (Pos('&',Copy(ligne,26,2))>0))
                                   or (RadioButton6.Checked and (Pos('#',Copy(ligne,26,2))>0))
                                   or (RadioButton2.Checked and (Pos('*',Copy(ligne,26,2))>0))
                                   or (RadioButton12.Checked and (Pos(MinMax,AAVSO_Mm[mois_demande])>0))
                                      ) ;
               end;
           until eof(f_asso);
           closefile(f_asso);
        end;
    end;
   Form7.Hide;
   Form1.TabSheet2Show(sender);
end;

procedure TForm7.FormShow(Sender: TObject);
begin
    If FileExists('LPV'+Copy(LabeledEdit1.Text,3,2)+'.dat') { *Converted from FileExists*  } then
       GroupBox1.Enabled:=true
    else
       Groupbox1.Enabled:=false;

    If FileExists('AFOEV'+Copy(LabeledEdit1.Text,3,2)+'.dat') { *Converted from FileExists*  } then
       GroupBox2.Enabled:=true
    else
       Groupbox2.Enabled:=false;
    if not Groupbox1.Enabled and not Groupbox2.Enabled then
    begin
       GroupBox3.Enabled:=false;
       IF langage='EN' then
          Button1.Caption:='Exit' else
          Button1.Caption:='Sortir';
    end
    else
    begin
       GroupBox3.Enabled:=True;
       IF langage='EN' then
          Button1.Caption:='Search...' else
          Button1.Caption:='Chercher...';
    end;
end;

procedure TForm7.LabeledEdit1Change(Sender: TObject);
begin
    FormShow(Sender);
//A traduire     if length(LabeledEdit1.Text)=4 then Form7.RecreateWnd;
end;

procedure TForm7.Button2Click(Sender: TObject);
begin
   RadioButton1.Checked:=false;
   RadioButton2.Checked:=false;
   RadioButton3.Checked:=false;
   RadioButton4.Checked:=false;
   RadioButton5.Checked:=false;
   RadioButton6.Checked:=false;
   RadioButton12.Checked:=false;

   RadioButton7.Checked:=false;
   RadioButton8.Checked:=false;
   RadioButton9.Checked:=false;
   RadioButton13.Checked:=false;
end;

procedure TForm7.FormCreate(Sender: TObject);
begin
   if langage='EN' then
   begin
      Form7.Caption:='Requests'; 
      Label1.Caption:='AFOEV && AAVSO Request for Observations';
      LabeledEdit1.EditLabel.Caption:='Campaign';
      CheckBoxFiltrage.Caption:='Use filters (Alpha, Delta, Type...)';
      GroupBox1.Caption:='Select star from AAVSO LPV Bulletins';
         Radiobutton1.Caption:='All stars';
         Radiobutton2.Caption:='% (Need of CCD observations)';
         Radiobutton3.Caption:='@ (Very urgent need of observ.)';
         Radiobutton4.Caption:='&& (Urgent need of observations)';
         Radiobutton5.Caption:='# (Need of observations';
         Radiobutton6.Caption:='* (Star without Max and min)';
         Radiobutton12.Caption:='Minima / Maxima for given month';

      GroupBox2.Caption:='Select star from AFOEV LPV Bulletins';
         Radiobutton7.Caption:='All stars';
         Radiobutton8.Caption:='! (Need of observations';
         Radiobutton9.Caption:='? (Date of maximum to search';
         Radiobutton13.Caption:=Radiobutton12.Caption;

      Label2.Caption:='Month';

      Button1.Caption:='Search';
      Button2.Caption:='Clear';
   end;
   ComboBox1.ItemIndex:=MonthOf(Date)-1;
end;

end.
